#!/bin/bash

# Original source:
# Copyright (C) 2012 Amazon.com, Inc. or its affiliates.
# All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License.
# A copy of the License is located at
#
#    http://aws.amazon.com/apache2.0/
#
# or in the "license" file accompanying this file. This file is
# distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
# OF ANY KIND, either express or implied. See the License for the
# specific language governing permissions and limitations under the
# License.

#
# Copyright (C) 2018 velostrata.com
# All Rights Reserved.
#

if grep -q Ubuntu /etc/issue ; then
	if [ -d /etc/netplan ] ; then
		interface=$(ls /sys/class/net/ | grep -v lo | head -n 1)
		new_prefix=$(/sbin/ip add show ${interface} | grep "inet " | awk '{print $2}' | cut -d "/" -f 2)
	fi
	/bin/bash -c "INTERFACE=${interface}; \
		PREFIX=${new_prefix}; \
		. /etc/velostrata/alias-ips/alias-ip-functions; \
		rewrite_rules; \
		rewrite_aliases"
elif [ -f "/etc/SuSE-release" ] ; then
    interface="$1"
    if [ "${interface}" != "lo" ]; then
		shift
		INTERFACE="${interface}"
		PREFIX=$(/sbin/ip add show ${INTERFACE} | grep "inet " | awk '{print $2}' | cut -d "/" -f 2)
		. /etc/velostrata/alias-ips/alias-ip-functions
		rewrite_rules
		rewrite_aliases
	fi
else
	INTERFACE="${interface}"
	PREFIX="${new_prefix}"
	. /etc/velostrata/alias-ips/alias-ip-functions

	aliasip_config() {
	  rewrite_rules
	  rewrite_aliases
	}

	aliasip_restore() {
	  remove_aliases
	  remove_rules
	}
fi
