#!/bin/bash

source /opt/velostrata/velostrata-functions

VELOS_DIR="/opt/velostrata/gcp"
UTIL_SCRIPTS_DIR="/etc/velostrata/gcpdns"
WICKED_SVC="/etc/wicked"
UBUNTU_NETPLAN="/etc/netplan"

DHCLIENT_SCRIPT="/etc/dhcp/dhclient.d/gcpdns.sh"
if is_ubuntu_family ; then
	DHCLIENT_SCRIPT="/etc/dhcp/dhclient-exit-hooks.d/gcpdns"
elif is_suse ; then
   DHCLIENT_SCRIPT="/etc/sysconfig/network/if-up.d/gcpdns"
fi


CFG=$1
velos_log_syslog "setup-gcp-dns, mode=${CFG}"

if [ "${CFG}" == "velos" ] ; then
	. $VELOS_DIR/gcpdns-utils
	update_dns_config
elif [ "${CFG}" == "detach" ] ; then
	mkdir -p $UTIL_SCRIPTS_DIR
	cp -f $VELOS_DIR/gcpdns-utils ${UTIL_SCRIPTS_DIR}/
	cp -f $VELOS_DIR/gcpdns.sh ${UTIL_SCRIPTS_DIR}/
	cp -f $VELOS_DIR/gcpdns.sh $DHCLIENT_SCRIPT
	if [ -d ${WICKED_SVC} ] ; then
		install_wicked_script $VELOS_DIR/wicked-gcpdns.sh
	fi
	if [ -d ${UBUNTU_NETPLAN} ] ; then
		install_systemd_service $VELOS_DIR/velostrata-gcpdns.service multi-user.target
	fi
	touch /etc/velostrata/actions/bypass/setup-gcp-dns
elif [ "${CFG}" == "origin" ] ; then
	rm -f $DHCLIENT_SCRIPT
	rm -rf $UTIL_SCRIPTS_DIR
	rm -f /etc/velostrata/actions/bypass/setup-gcp-dns
	. $VELOS_DIR/gcpdns-utils
	restore_dns_config
else
	velos_log_syslog "Unknown mode for setup-gcp-dns, supported: origin / velos / detached)"
fi

